
FS_VIBRO_SIMULATOR_interrupt:

;FS_VIBRO_SIMULATOR.mbas,61 :: 		sub procedure interrupt()    ' Main Interrupt Routine
;FS_VIBRO_SIMULATOR.mbas,62 :: 		HID_InterruptProc
	CALL        _HID_InterruptProc+0, 0
L_FS_VIBRO_SIMULATOR_interrupt51:
	RETFIE      1
; end of FS_VIBRO_SIMULATOR_interrupt

FS_VIBRO_SIMULATOR_Init_Main:

;FS_VIBRO_SIMULATOR.mbas,67 :: 		sub procedure Init_Main()    ' Initialization Routine
;FS_VIBRO_SIMULATOR.mbas,71 :: 		INTCON = 0                             ' Disable GIE, PEIE, TMR0IE,INT0IE, RBIE
	CLRF        INTCON+0 
;FS_VIBRO_SIMULATOR.mbas,72 :: 		INTCON2 = 0x75                         ' Turn on PORTB pull-ups
	MOVLW       117
	MOVWF       INTCON2+0 
;FS_VIBRO_SIMULATOR.mbas,73 :: 		INTCON3 = 0xC0
	MOVLW       192
	MOVWF       INTCON3+0 
;FS_VIBRO_SIMULATOR.mbas,74 :: 		RCON.IPEN = 0                          ' Disable Priority Levels on interrupts
	BCF         RCON+0, 7 
;FS_VIBRO_SIMULATOR.mbas,75 :: 		PIE1 = 0
	CLRF        PIE1+0 
;FS_VIBRO_SIMULATOR.mbas,76 :: 		PIE2 = 0
	CLRF        PIE2+0 
;FS_VIBRO_SIMULATOR.mbas,77 :: 		PIR1 = 0
	CLRF        PIR1+0 
;FS_VIBRO_SIMULATOR.mbas,78 :: 		PIR2 = 0
	CLRF        PIR2+0 
;FS_VIBRO_SIMULATOR.mbas,79 :: 		ADCON1 = ADCON1 or 0x06                ' Configure RA0 - RA3, RA5 and RB2 as analog, all others as digital
	MOVLW       6
	IORWF       ADCON1+0, 1 
;FS_VIBRO_SIMULATOR.mbas,81 :: 		TRISA = 0xFF                           ' PORTA input
	MOVLW       255
	MOVWF       TRISA+0 
;FS_VIBRO_SIMULATOR.mbas,82 :: 		TRISB = 0x00  PORTB = 0x00             ' PORTB output
	CLRF        TRISB+0 
	CLRF        PORTB+0 
;FS_VIBRO_SIMULATOR.mbas,83 :: 		TRISC = 0x00  PORTC = 0x00             ' PORTC output
	CLRF        TRISC+0 
	CLRF        PORTC+0 
;FS_VIBRO_SIMULATOR.mbas,84 :: 		LATA = 0
	CLRF        LATA+0 
;FS_VIBRO_SIMULATOR.mbas,85 :: 		LATB = 0
	CLRF        LATB+0 
;FS_VIBRO_SIMULATOR.mbas,86 :: 		LATC = 0
	CLRF        LATC+0 
;FS_VIBRO_SIMULATOR.mbas,87 :: 		PWM1_Init(3000)             ' Initialize PWM1 module at 3 KHz
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	BSF         T2CON+0, 0, 0
	BSF         T2CON+0, 1, 0
	MOVLW       249
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;FS_VIBRO_SIMULATOR.mbas,88 :: 		PWM2_Init(3000)             ' Initialize PWM2 module at 3 KHz
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	BSF         T2CON+0, 0, 0
	BSF         T2CON+0, 1, 0
	MOVLW       249
	MOVWF       PR2+0, 0
	CALL        _PWM2_Init+0, 0
	RETURN      0
; end of FS_VIBRO_SIMULATOR_Init_Main

_main:

;FS_VIBRO_SIMULATOR.mbas,93 :: 		MAIN:                        ' Main Program Routine
;FS_VIBRO_SIMULATOR.mbas,94 :: 		Init_Main()
	CALL        FS_VIBRO_SIMULATOR_Init_Main+0, 0
;FS_VIBRO_SIMULATOR.mbas,95 :: 		FOR BR = 0 TO 8
	CLRF        _BR+0 
L__main4:
;FS_VIBRO_SIMULATOR.mbas,96 :: 		userWR_buffer[BR] = 0x00  ' Initialize everything to 0
	MOVLW       _userWR_buffer+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_userWR_buffer+0)
	MOVWF       FSR1H 
	MOVF        _BR+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	CLRF        POSTINC1+0 
;FS_VIBRO_SIMULATOR.mbas,97 :: 		NEXT BR
	MOVF        _BR+0, 0 
	XORLW       8
	BTFSC       STATUS+0, 2 
	GOTO        L__main7
	INCF        _BR+0, 1 
	GOTO        L__main4
L__main7:
;FS_VIBRO_SIMULATOR.mbas,98 :: 		PWM1_Start()                       ' start PWM1
	CALL        _PWM1_Start+0, 0
;FS_VIBRO_SIMULATOR.mbas,99 :: 		PWM2_Start()                       ' start PWM2
	CALL        _PWM2_Start+0, 0
;FS_VIBRO_SIMULATOR.mbas,100 :: 		HID_Enable(@userRD_buffer, @userWR_buffer)
	MOVLW       _userRD_buffer+0
	MOVWF       FARG_HID_Enable_ReadBuff+0 
	MOVLW       hi_addr(_userRD_buffer+0)
	MOVWF       FARG_HID_Enable_ReadBuff+1 
	MOVLW       _userWR_buffer+0
	MOVWF       FARG_HID_Enable_WriteBuff+0 
	MOVLW       hi_addr(_userWR_buffer+0)
	MOVWF       FARG_HID_Enable_WriteBuff+1 
	CALL        _HID_Enable+0, 0
;FS_VIBRO_SIMULATOR.mbas,101 :: 		Delay_ms(1000)
	MOVLW       61
	MOVWF       R11, 0
	MOVLW       225
	MOVWF       R12, 0
	MOVLW       63
	MOVWF       R13, 0
L__main8:
	DECFSZ      R13, 1, 0
	BRA         L__main8
	DECFSZ      R12, 1, 0
	BRA         L__main8
	DECFSZ      R11, 1, 0
	BRA         L__main8
	NOP
	NOP
;FS_VIBRO_SIMULATOR.mbas,102 :: 		Delay_ms(1000)
	MOVLW       61
	MOVWF       R11, 0
	MOVLW       225
	MOVWF       R12, 0
	MOVLW       63
	MOVWF       R13, 0
L__main9:
	DECFSZ      R13, 1, 0
	BRA         L__main9
	DECFSZ      R12, 1, 0
	BRA         L__main9
	DECFSZ      R11, 1, 0
	BRA         L__main9
	NOP
	NOP
;FS_VIBRO_SIMULATOR.mbas,106 :: 		WHILE TRUE
L__main11:
;FS_VIBRO_SIMULATOR.mbas,107 :: 		DUTY_REF = (Adc_Read(0)>> 2) - 128
	CLRF        FARG_Adc_Read_channel+0 
	CALL        _Adc_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _DUTY_REF+0 
	MOVF        R1, 0 
	MOVWF       _DUTY_REF+1 
	RRCF        _DUTY_REF+1, 1 
	RRCF        _DUTY_REF+0, 1 
	BCF         _DUTY_REF+1, 7 
	RRCF        _DUTY_REF+1, 1 
	RRCF        _DUTY_REF+0, 1 
	BCF         _DUTY_REF+1, 7 
	MOVLW       128
	SUBWF       _DUTY_REF+0, 1 
	MOVLW       0
	SUBWFB      _DUTY_REF+1, 1 
;FS_VIBRO_SIMULATOR.mbas,109 :: 		IF  userRD_buffer[7] > 0 THEN PWM1_Start()LED_LL = 1 ELSE LED_LL = 0 END IF
	MOVF        _userRD_buffer+7, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main16
	CALL        _PWM1_Start+0, 0
	BSF         PORTB+0, 0 
	GOTO        L__main17
L__main16:
	BCF         PORTB+0, 0 
L__main17:
;FS_VIBRO_SIMULATOR.mbas,110 :: 		IF  userRD_buffer[0] > 0 THEN PWM2_Start()LED_DD = 1 ELSE LED_DD = 0 END IF
	MOVF        _userRD_buffer+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main19
	CALL        _PWM2_Start+0, 0
	BSF         PORTB+0, 7 
	GOTO        L__main20
L__main19:
	BCF         PORTB+0, 7 
L__main20:
;FS_VIBRO_SIMULATOR.mbas,112 :: 		DUTY_PWM1 = (userRD_buffer[0]>> 1) + DUTY_REF
	MOVF        _userRD_buffer+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	ADDWF       _DUTY_REF+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      _DUTY_REF+1, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	MOVWF       _DUTY_PWM1+0 
	MOVF        R2, 0 
	MOVWF       _DUTY_PWM1+1 
;FS_VIBRO_SIMULATOR.mbas,113 :: 		IF DUTY_PWM1 < 0 THEN DUTY_PWM1 = 0 END IF
	MOVLW       128
	XORWF       R2, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main52
	MOVLW       0
	SUBWF       R1, 0 
L__main52:
	BTFSC       STATUS+0, 0 
	GOTO        L__main22
	CLRF        _DUTY_PWM1+0 
	CLRF        _DUTY_PWM1+1 
L__main22:
;FS_VIBRO_SIMULATOR.mbas,114 :: 		IF DUTY_PWM1 > 255 THEN DUTY_PWM1 = 255 END IF
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       _DUTY_PWM1+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main53
	MOVF        _DUTY_PWM1+0, 0 
	SUBLW       255
L__main53:
	BTFSC       STATUS+0, 0 
	GOTO        L__main25
	MOVLW       255
	MOVWF       _DUTY_PWM1+0 
	MOVLW       0
	MOVWF       _DUTY_PWM1+1 
L__main25:
;FS_VIBRO_SIMULATOR.mbas,115 :: 		PWM1_Set_Duty(DUTY_PWM1)
	MOVF        _DUTY_PWM1+0, 0 
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;FS_VIBRO_SIMULATOR.mbas,116 :: 		DUTY_PWM2 = (userRD_buffer[7]>> 1) + DUTY_REF
	MOVF        _userRD_buffer+7, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	ADDWF       _DUTY_REF+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      _DUTY_REF+1, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	MOVWF       _DUTY_PWM2+0 
	MOVF        R2, 0 
	MOVWF       _DUTY_PWM2+1 
;FS_VIBRO_SIMULATOR.mbas,117 :: 		IF DUTY_PWM2 < 0 THEN DUTY_PWM2 = 0 END IF
	MOVLW       128
	XORWF       R2, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main54
	MOVLW       0
	SUBWF       R1, 0 
L__main54:
	BTFSC       STATUS+0, 0 
	GOTO        L__main28
	CLRF        _DUTY_PWM2+0 
	CLRF        _DUTY_PWM2+1 
L__main28:
;FS_VIBRO_SIMULATOR.mbas,118 :: 		IF DUTY_PWM2 > 255 THEN DUTY_PWM2 = 255 END IF
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       _DUTY_PWM2+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main55
	MOVF        _DUTY_PWM2+0, 0 
	SUBLW       255
L__main55:
	BTFSC       STATUS+0, 0 
	GOTO        L__main31
	MOVLW       255
	MOVWF       _DUTY_PWM2+0 
	MOVLW       0
	MOVWF       _DUTY_PWM2+1 
L__main31:
;FS_VIBRO_SIMULATOR.mbas,119 :: 		PWM2_Set_Duty(DUTY_PWM2)
	MOVF        _DUTY_PWM2+0, 0 
	MOVWF       FARG_PWM2_Set_Duty_new_duty+0 
	CALL        _PWM2_Set_Duty+0, 0
;FS_VIBRO_SIMULATOR.mbas,121 :: 		IF  userRD_buffer[1] > 0 THEN MOTOR_1 = 1 ELSE MOTOR_1 = 0 END IF
	MOVF        _userRD_buffer+1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main34
	BSF         PORTB+0, 1 
	GOTO        L__main35
L__main34:
	BCF         PORTB+0, 1 
L__main35:
;FS_VIBRO_SIMULATOR.mbas,122 :: 		IF  userRD_buffer[2] > 0 THEN MOTOR_2 = 1 ELSE MOTOR_2 = 0 END IF
	MOVF        _userRD_buffer+2, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main37
	BSF         PORTB+0, 2 
	GOTO        L__main38
L__main37:
	BCF         PORTB+0, 2 
L__main38:
;FS_VIBRO_SIMULATOR.mbas,123 :: 		IF  userRD_buffer[3] > 0 THEN MOTOR_3 = 1 ELSE MOTOR_3 = 0 END IF
	MOVF        _userRD_buffer+3, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main40
	BSF         PORTB+0, 3 
	GOTO        L__main41
L__main40:
	BCF         PORTB+0, 3 
L__main41:
;FS_VIBRO_SIMULATOR.mbas,124 :: 		IF  userRD_buffer[4] > 0 THEN MOTOR_4 = 1 ELSE MOTOR_4 = 0 END IF
	MOVF        _userRD_buffer+4, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main43
	BSF         PORTB+0, 4 
	GOTO        L__main44
L__main43:
	BCF         PORTB+0, 4 
L__main44:
;FS_VIBRO_SIMULATOR.mbas,125 :: 		IF  userRD_buffer[5] > 0 THEN MOTOR_5 = 1 ELSE MOTOR_5 = 0 END IF
	MOVF        _userRD_buffer+5, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main46
	BSF         PORTB+0, 5 
	GOTO        L__main47
L__main46:
	BCF         PORTB+0, 5 
L__main47:
;FS_VIBRO_SIMULATOR.mbas,126 :: 		IF  userRD_buffer[6] > 0 THEN MOTOR_6 = 1 ELSE MOTOR_6 = 0 END IF
	MOVF        _userRD_buffer+6, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main49
	BSF         PORTB+0, 6 
	GOTO        L__main50
L__main49:
	BCF         PORTB+0, 6 
L__main50:
;FS_VIBRO_SIMULATOR.mbas,128 :: 		HID_Write(@userWR_buffer, 8)
	MOVLW       _userWR_buffer+0
	MOVWF       FARG_HID_Write_Buffer+0 
	MOVLW       hi_addr(_userWR_buffer+0)
	MOVWF       FARG_HID_Write_Buffer+1 
	MOVLW       8
	MOVWF       FARG_HID_Write_Len+0 
	CALL        _HID_Write+0, 0
;FS_VIBRO_SIMULATOR.mbas,130 :: 		WEND
	GOTO        L__main11
;FS_VIBRO_SIMULATOR.mbas,135 :: 		HID_Disable()
	GOTO        $+0
; end of _main
